//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ImportDlg.h"
#include "global.h"
#include "fileman.h"
#include "mixmaster.h"
#include "pgpmail.h"
#include "helpdlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TImportDlg *ImportDlg;
//---------------------------------------------------------------------------
bool __fastcall ImportPgpKeyrings(AnsiString &ImportFile, AnsiString &PubFile,
   AnsiString &SecFile, TForm *Owner)
{
   bool ok=false;
   AnsiString mringtxt=MixDir()+MRingTxt;
   if (PubFile.IsEmpty() || SecFile.IsEmpty())
   {
      AnsiString pub=AppDir+"pubring.pkr",sec=AppDir+"secring.skr";
      int reply = MsgBoxHwnd(Owner->Handle,
         s("You haven't specified keyring files! I'll create them for you.\n\n")+
         s(pub+"\n")+
         s(sec+"\n\n"),
         s("Creating Keyrings"),
          MB_OKCANCEL
      );
      if (reply==IDCANCEL) return ok;
      PubFile = pub;
      SecFile = sec;
   }
   TImportDlg *id = new TImportDlg(Owner); CenterDialog(id,Owner);
   id->ImportFileName->Text = ImportFile;

   id->Pubring = PubFile.IsEmpty() ? PGPPubRing : PubFile;
   id->Secring = SecFile.IsEmpty() ? PGPSecRing : SecFile;
   if (GetAppIni("ImportKeysReplace","").ToIntDef(1)) id->ReplaceBox->Checked = true;
   else id->AddnewBox->Checked = true;

   if (!FileExists(id->Pubring) && !FileExists(id->Secring))
   {
      id->ReplaceBox->Checked = true;
      id->AddnewBox->Enabled = false;
   }
   id->Top -= 8;
   id->ShowModal();
   if (id->ModalResult==mrOk && HasPgp())
   {
      ImportFile = id->ImportFileName->Text;
      PubFile = id->Pubring;
      SecFile = id->Secring;
      Sleep(300);
      ok = true;
   }
   delete id;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TImportDlg::TImportDlg(TComponent* Owner)
  : TForm(Owner)
{
   ImportFileName->Text = GetAppIni(PgpImpRing,"");//PgpImportFile);
   // init OpenImport dialog
   OpenImport->InitialDir = AppDir;
   OpenImport->FileName = "";//PgpImportFile;
   AnsiString curimpring=GetAppIni(PgpImpRing,"");//PgpImportFile);
   if (FileExists(curimpring))
   {
      OpenImport->InitialDir = ExtractFilePath(curimpring);
      OpenImport->FileName = ExtractFileName(curimpring);
   }
   OpenImport->Filter = "Import Keyring Files (*.asc)|*.ASC|All Files (*.*)|*.*";
}
//---------------------------------------------------------------------------
void __fastcall TImportDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("OptionsPgpImport","Importing PGP Keyrings","",this);
}
//---------------------------------------------------------------------------
void __fastcall TImportDlg::Button2Click(TObject *Sender)
{
   if (!FileExists(PGPPubRing) && !FileExists(PGPSecRing))
   {
      ReplaceBox->Checked = true;
      AddnewBox->Enabled = false;
   }
   Pubring = PGPPubRing;
   Secring = PGPSecRing;
   ActiveControl = ImportFileName;
   ImportFileName->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TImportDlg::Button1Click(TObject *Sender)
{
   AnsiString fname = ImportFileName->Text;
   if (fname.IsEmpty())
   {
      OpenImport->InitialDir = ExtractFilePath(fname);
      OpenImport->FileName = ExtractFileName(fname);
   }
   if (OpenImport->Execute())
      ImportFileName->Text = OpenImport->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TImportDlg::OkBtnClick(TObject *Sender)
{
   if (ImportFileName->Text.IsEmpty())
   {
      MyBeep(MB_OK);
      return;
   }
   if (!FileExists(ImportFileName->Text))
   {
      MsgBoxHwnd(Handle,
         "The file: "+ImportFileName->Text+"\ndoes not exist!",
         "Import Error",
          MB_OK);
      return;
   }
   if (MsgBoxHwnd(Handle,"Import keys now?","Confirm",MB_OKCANCEL)==IDCANCEL)
      return;

   Cursor = crHourGlass;
   if (ReplaceBox->Checked)
   {
      PutAppIni("ImportKeysReplace","1");
      PgpImportKeysReplace(ImportFileName->Text.c_str(),
         Pubring.c_str(),Secring.c_str(),DeleteBox->Checked
      );
   }
   else //if (AddnewBox->Checked)
   {
      PutAppIni("ImportKeysReplace","0");
      PgpImportKeysAddNew(ImportFileName->Text.c_str(),
         Pubring.c_str(),Secring.c_str(),DeleteBox->Checked
      );
   }
   Sleep(200);
   Cursor = crDefault;
   MsgBoxHwnd(Handle,"      Ok, it's done!      ","QSPGP Import",MB_OK);
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TImportDlg::CancelBtnClick(TObject *Sender)
{
   ModalResult = CancelBtn->Caption=="Cancel" ? mrCancel : mrOk;
}
//---------------------------------------------------------------------------

