//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <vcl\ComCtrls.hpp>
#include "mixmsg.h"
#include "mixmaster.h"
#include "global.h"
#include "headman.h"
#include "wiper.h"
#include "console.h"
#include "version.h"
#include "fileman.h"
//#include "mixthrd.h"
#define DISPLAY(msg) display->Add(msg)
//---------------------------------------------------------------------------
long __fastcall MixPoolCount()
{
   int count=0;
   if (FileExists(AppMixPool))
   {
      TStringList *pool = new TStringList();
      GetAppData(pool,MixPoolKey,AppMixPool);
      count = pool->Count;
      delete pool;
      if (!count) simplewipe(AppMixPool,2);
   }
   return count;
}
//---------------------------------------------------------------------------
void __fastcall MixPoolClear(TStringList *ofFiles)
{
   TStringList *files = new TStringList();
   if (!ofFiles)
      GetFilenames(files,QUEUEFILES);
   else
      files->AddStrings(ofFiles);
   for (int i=0; i<files->Count; i++)
      DeleteFile(files->Strings[i].c_str());
   delete files;
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::TMixMessage(TStringList *message, TStrings *aDisplay,
   TProgressBar *progressbar)
{
   Finished = false;
   Cancelled = false;
   Message = message;
   display = aDisplay;
   Feedback = new TStringList();

   HeadMan = new THeaderManager(Message);
   From = HeadMan->Get("From: "); HeadMan->Delete("From: ");
   Host = HeadMan->Get("Host: "); HeadMan->Delete("Host: ");
   AnsiString tmpc = HeadMan->GetDat("Chain: ",Message);
   HeadMan->Delete("Chain: ");
   HeadMan->Delete("Fcc: ");

   Copies = GetParam(1,tmpc,"=").Trim().ToIntDef(1); if (Copies==0) Copies++;
   Chain = GetParam(0,tmpc,";").Trim(); tmpc = GetParam(1,tmpc,";").Trim();
   ProgressBar = progressbar;
   MixPoolClear();
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::~TMixMessage()
{
   delete HeadMan;
   delete Feedback;
}
//---------------------------------------------------------------------------
//#define CheckErrorLog(m) Application->MainForm->Perform(WM_GETERRORLOG,m,NULL)
long __fastcall TMixMessage::MixMessage(TStrings *Message, AnsiString &Chain, int copies,
   TStringList *Feedback)
{
   int i;
   long ret;
   BUFFER *msg=buf_new(),*fbk=buf_new();
   if (!msg || !fbk) return -2;

   msg->sensitive = true; fbk->sensitive = true;
   for (i=0; i<Message->Count; i++)
   {
//  if (i==Message->Count-1 && Message->Strings[i].IsEmpty()) break;
      AnsiString line = Message->Strings[i];
      buf_append(msg,(byte*)line.c_str(),line.Length());
      buf_append(msg,(byte*)"\n",1);
   }

/* TMixThread *MT = new TMixThread(false);
   MT->SetValsAndStart(MSG_MAIL,msg,Chain.c_str(),copies,fbk);
   while (MT->Running && !MT->Finished && !Cancelled)
   {
      Application->ProcessMessages();
   }
   if (Cancelled && !MT->Finished) MT->Suspend();
   Sleep(500);
   if (MT->Result==0) mix_send();
   ret = MT->Result;
   delete MT;
*/
//sm(Message->Text);
   if ((ret=mix_encrypt_exe(MSG_MAIL,msg,Chain.c_str(),copies,fbk,&Cancelled,
      ProgressBar))==0)
         mix_send();
//sm("ok");
   Feedback->Text = AnsiString((char*)fbk->data);
   for (i=0; i<Feedback->Count; i++)
      Feedback->Strings[i]=" "+Feedback->Strings[i];
   buf_free(msg); buf_free(fbk);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall StringInList(AnsiString &String, TStringList *List)
{
   bool isin=false;
   for (int i=0; i<List->Count; i++)
   {
      if (List->Strings[i]==String)
      {
         isin = true;
         break;
      }
   }
   return isin;
}
//---------------------------------------------------------------------------
void DeleteStrings(TStrings *FromList, TStrings *ThatAreInList)
{
   int f=0; while (f<FromList->Count)
   {
      int pos = -1;
      for (int i=0; i<ThatAreInList->Count; i++)
      {
         if (FromList->Strings[f]==ThatAreInList->Strings[i])
         {
            pos = f;
            break;
         }
      }
      if (pos>=0)
         FromList->Delete(pos);
      else
         f++;
   }
}
//---------------------------------------------------------------------------
long __fastcall TMixMessage::Execute()
{
   long ret=0;
   AnsiString s,S,text,Name,curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);
   DISPLAY("Mixmaster encrypting... ");
   Application->ProcessMessages();

   if ((ret=MixMessage(Message,Chain,Copies,Feedback))==0)
   {
      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles,QUEUEFILES);
      if (!Cancelled)
      {
         DISPLAY("Mixmaster reports : ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            Application->ProcessMessages();
         }

         DeleteStrings(outfiles,prefiles);
         for (int i=0; i<outfiles->Count; i++)
         {
            s = outfiles->Strings[i];
            if (!Cancelled)
            {
               curstr = (i+1<10? " ":"")+AnsiString(i+1);
               Name = MixmasterChain+" "+curstr+" of "+AnsiString(outfiles->Count);
               msg->LoadFromFile(s); msg->Delete(0);
               msg->Insert(0,Host);
               msg->Insert(1,From);
               PutAppData(MixPoolKey+PS+Name,msg,AppMixPool);
            }
            simplewipe(s,2);
         }
      }
      else
         simplewipe(AppMixPool,2);
      delete outfiles;
      delete msg;
   }

   delete prefiles;

   if (!Cancelled)
   {
      if (ret!=0)
      {
         int lo=LOWORD(ret),hi=HIWORD(ret);
         DISPLAY("Error: ( "+AnsiString((int)lo)+" , "+AnsiString((int)hi)+" ) encrypting message");
         switch (hi)
         {
            case 2: Feedback->Add("Client error condition\n"); break;
            case 1: Feedback->Add("Commandline error\n"); break;
         }
         DISPLAY("Mixmaster reports : ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            Application->ProcessMessages();
         }
      }
   }
   Finished = true;
   return ret;
}
//---------------------------------------------------------------------------
