//---------------------------------------------------------------------------
#ifndef pgpdbH
#define pgpdbH

#include "mixmaster.h"
//---------------------------------------------------------------------------
class TPgpMsg : public TObject
{
private:
   AnsiString __fastcall idtext8(BUFFER *pkt);
public:
   int status;
   BUFFER *buf;
   virtual __fastcall TPgpMsg(TStrings *AsciiMessage); // armored
   virtual __fastcall TPgpMsg(BUFFER *Message); // armored or non
   virtual __fastcall TPgpMsg(char* Message);  // armored or non
   __fastcall~TPgpMsg();
   bool __fastcall IsConventional();
   void __fastcall GetMsgInfo();
   AnsiString __fastcall Description(BUFFER *pkt); // provides info on key for debug purposes
   AnsiString __fastcall IdText8();
   void __fastcall KeyId(BUFFER *Keyid, BUFFER *pkt);
   byte __fastcall Algorithm(BUFFER *pkt);
   byte __fastcall Version(BUFFER *pkt);
   byte __fastcall CTB(BUFFER *pkt);
};

class TPgpDBKey : public TObject
{
private:
   int __fastcall GetMPI(BUFFER *mpi);
   int __fastcall PutMPI(BUFFER *buf, BUFFER *mpi);
public:
   int status;
   BUFFER *key;
   TPgpDBKey *pair;
   virtual __fastcall TPgpDBKey(BUFFER *BinKey);
   virtual __fastcall TPgpDBKey(TPgpDBKey *Key);
   virtual __fastcall TPgpDBKey(TStrings *AsciiKey);
   __fastcall~TPgpDBKey();
   long __fastcall Write(TFileStream *Stream);
   int __fastcall KeyId(BUFFER *Keyid);
   AnsiString __fastcall Description();
   AnsiString __fastcall AsciiArmored();
   AnsiString __fastcall IdText8();
   AnsiString __fastcall KeyUserIds(int pos=-1);
   int  __fastcall Validity();
   int  __fastcall KeyBits();
   byte __fastcall Algorithm();
   byte __fastcall Version();
   long __fastcall TimeStamp();
   bool __fastcall IsPair();
   int  __fastcall Type();
};

class TPgpDB : public TObject
{
public:
   int status;
   bool modified;
   TStringList *keys;
   bool allowduplicates;
   // constructors
   virtual __fastcall TPgpDB(AnsiString KeyFile);
   virtual __fastcall TPgpDB(TStrings *AsciiKeys);
//   virtual __fastcall TPgpDB(char *KeyFile);
   // destructors
   virtual __fastcall TPgpDB();
   virtual __fastcall~TPgpDB();
   // save methods
   TPgpDBKey* __fastcall GetKey(int Pos);
   void __fastcall SaveToFile(AnsiString &FileName, bool Armored=true);
   void __fastcall SaveToFileBak(AnsiString &FileName, int bakcopies, bool Armored=true);
   TStrings* __fastcall SaveToStrings(TStrings *AsciiStrings);
   BUFFER* __fastcall SaveToBuffer(BUFFER *BinBuf);
   AnsiString __fastcall SaveToString();
   // add methods
   virtual int __fastcall AddKey(BUFFER *KeyBuf);
   virtual int __fastcall AddKey(TPgpDBKey *Key);
   virtual int __fastcall AddKey(TStrings *AsciiKey);
   // remove
   int __fastcall Delete(int Item);
   // utility
   virtual int __fastcall Find(BUFFER *KeyBuf);
   virtual int __fastcall Find(TPgpDBKey *Key);
   int __fastcall FindDescrip(AnsiString &Descrip);
   int __fastcall KeyCount();
   void __fastcall Clear();
};

const AnsiString PgpBeginPubKeyBlock = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpEndPubKeyBlock = "-----END PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpBeginSecKeyBlock = "-----BEGIN PGP SECRET KEY BLOCK-----";
const AnsiString PgpEndSecKeyBlock = "-----END PGP SECRET KEY BLOCK-----";
const bool Armored = true;
#endif
